#!/usr/bin/env python
import sys
import gtk
import gtk.glade
import os
import gobject
import string
import commands
from Constants import *


##get bootsplash conf
conf = commands.getoutput('whereis bootsplash')
conftemp = string.split(conf,': ')
conftab = string.split(conftemp[1],' ')

##bootsplash chooser conf
bootsplash_themes_path = conftab[1]+"/themes/"
bootsplash_scripts_path = conftab[1]+"/scripts/"

current_dir = os.getcwd()
#print current_dir
glade_file = PI_MODULES_GUI	+ "/bootsplash-chooser.glade"

#################################
# create widget tree
try:
	widget_tree = gtk.glade.XML(glade_file)
except :
	print (glade_file+' not found in '+glade_path)


#create widgets objects from the widget tree
window_themes = widget_tree.get_widget('window_themes')
scrolled_themes = widget_tree.get_widget('scrolledwindow_themes')
treeview_themes = widget_tree.get_widget('treeview_themes')
statusbar_themes = widget_tree.get_widget('statusbar_themes')
exit_button_themes = widget_tree.get_widget('exit_button_themes')
##################################



#-------------------------------- Functions -------------------------------------------------
def current_theme(treeview):
	pass


def install_theme(treeview,tupl,theme):
#install the theme selected with the treeview (the View object of MVC)
	treeview.set_sensitive(0)
	selection = treeview.get_selection()
	liststore_selected = selection.get_selected()
	selection.set_mode(gtk.SELECTION_SINGLE)
	model, iter = liststore_selected

	#get the value of the selected element
	value = model.get_value(iter,0)
	#print '+'+value+'+'
		
	command=bootsplash_scripts_path + '/switch-themes ' + value
	#INSTALL the selected theme
	try:	
		statusbar_themes.push(0,"installing "+value+"theme")
		os.system(command)
	except:
		statusbar_themes.push(0,"could not install "+value+" theme")
	else:
		statusbar_themes.push(0,"theme "+value+ " installed")
	treeview.set_sensitive(1)
#end def install_theme

def install_selected_theme(treeview):
#install the theme selected with the treeview (the View object of MVC)


	selection = treeview.get_selection()
	liststore_selected = selection.get_selected()
	selection.set_mode(gtk.SELECTION_SINGLE)
	model, iter = liststore_selected

	#get the value of the selected element
	value = model.get_value(iter,0)
	#print '+'+value+'+'
		
	command=bootsplash_scripts_path + '/switch-themes ' + value
	#INSTALL the selected theme
	try:	
		statusbar_themes.push(0,"installing "+value+"theme")
		os.system(command)
	except:
		statusbar_themes.push(0,"could not install "+value+" theme")
		return 0
	else:
		statusbar_themes.push(0,"theme "+value+ " installed")
		return 1

#end def install_selected_theme

def installnquit_selected_theme(treeview):
#install the theme selected with the treeview and quit the main program
	if  install_selected_theme(treeview):
		gtk.mainquit()
#end def installnquit_selected_theme
	
#--------------------------------- Main part of the script ---------------------------------

#get the list themes installed with the lilo presence
themes = os.listdir(bootsplash_themes_path)

#create model store
store_themes = gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_OBJECT,gobject.TYPE_OBJECT,gobject.TYPE_OBJECT)

#store datas in the ListStore
try:
	for item in themes:
		#create a new row in the store
		iter = store_themes.append()
	
		image = gtk.Image()
		image.set_from_file(bootsplash_themes_path+item+'/images/bootsplash-800x600.jpg')
		pix = image.get_pixbuf()
		pix_little_boot = pix.scale_simple(80,60,1)

		if os.path.isfile(bootsplash_themes_path+item+'/images/silent-800x600.jpg'):
			image = gtk.Image()
			image.set_from_file(bootsplash_themes_path+item+'/images/silent-800x600.jpg')
			print image.get_storage_type()
			pix = image.get_pixbuf()
			pix_little_silent = pix.scale_simple(80,60,1)
		else:
			#create an empty image if no silent jpg
			image = gtk.Image()
			pix_little_silent = image.get_pixbuf()
	
	#	image = gtk.Image()
#		if os.path.isfile(bootsplash_themes_path+item+'lilo/message'):
		image1 = gtk.Image()
		image1.set_from_stock('stock-yes',60)

#		image2 = image1.get_image()
#		print image1.get_storage_type()
#		image2 = image1.get_pixbuf()
#		image2 = image1.get_image()
#	lilo = image2.get_pixbuf()
#		else:
#			image = gtk.Image()
#			image.set_from_stock('stock-no',20)
#			lilo = image.get_pixbuf()
			
	
		store_themes.set(iter,0,item)
		store_themes.set(iter,1,pix_little_boot)
		store_themes.set(iter,2,pix_little_silent)
		store_themes.set(iter,3,image1)
except:
	statusbar_themes.push(0,"load themes failed")
	print sys.exc_value
else:
	statusbar_themes.push(0,"bootsplash themes loaded")

#-------------------------------- Interface Part with Glade-------------------------------------------------


#connect signals
menu_dic = {"on_treeview_themes_row_activated" : install_theme,
	"on_button_apply_themes_clicked" : install_selected_theme,
	"on_button_valid_themes_clicked" : installnquit_selected_theme,
	"on_button_quit_themes_clicked" : gtk.mainquit,
	"on_window_themes_destroy" : gtk.mainquit,
	"on_exit_button_themes_clicked" : gtk.mainquit}
widget_tree.signal_autoconnect(menu_dic)

#connect model with treeview
treeview_themes.set_model(store_themes)

#COLUMN A : creation, cellrenderer and model column
columnA = gtk.TreeViewColumn('theme',gtk.CellRendererText(),text=0)

#COLUMN B
columnB = gtk.TreeViewColumn('image',gtk.CellRendererPixbuf(),pixbuf=1)

#COLUMN C
columnC = gtk.TreeViewColumn('lilo',gtk.CellRendererPixbuf(),pixbuf=3)

#COLUMN D
columnD = gtk.TreeViewColumn('image',gtk.CellRendererPixbuf(),pixbuf=2)

#pack treeview-column with treeview
treeview_themes.append_column(columnB) #1st column
treeview_themes.append_column(columnD) #1st column
treeview_themes.append_column(columnA) #2nd column 
treeview_themes.append_column(columnC) #3rd column

gtk.main()
